#!/usr/bin/python2.7
# -*- coding: utf-8 -*-
# Maintainer: 49-kun

import urllib2
import json
import re
import sys
import time
import os
import urllib

headers = {
        "Host" : "dobrochan.com",
        "Connection" : "keep-alive",
        "Cache-Control" : "max-age=0",
        "User-Agent" : "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.48 Safari/537.36",
        "Accept-Language" : "ru,en-US;q=0.8,en;q=0.6"
        }

def getImages(board, thread):
        request = urllib2.Request("http://dobrochan.com/api/thread/%s/%s/all.json" % (board, thread), None, headers)
        response = urllib2.urlopen(request)

        data = response.read();
        posts = json.loads(data)

        path = '{0}/{1}/'.format(board, thread)
        if not os.path.exists(path):
                os.makedirs(path)

        for post in posts['posts']:
                if len(post['files']) == 0:
                        continue

                for fl in post['files']:
                        src = urllib.quote(fl['src'].encode('utf-8'))
                        fil = fl['src'].split('/')
                        fname = fil[ len(fil) - 1]

                        print 'http://dobrochan.com/%s' % src
                        f = urllib2.urlopen('http://dobrochan.com/%s' % src)
                        print "%s%s" % (path,fname)
                        with open("%s%s" % (path,fname), "wb") as code:
                                code.write(f.read())

def getThreads(board):
        page = "index"
        while True:
                try:
                        request = urllib2.Request("http://dobrochan.com/%s/%s.xhtml" % (board, page), None, headers)
                        response = urllib2.urlopen(request)

                        data = response.read()
                        result = re.findall( r'"/%s/res/([0-9]*).xhtml">' % board, data)

                        if page == 'index':
                                page = 1
                        else:
                                page += 1

                        for thread in result:
                                getImages(board, thread)

                        print "Page {0} in /{1}/ board. Threads".format(page, board)
                        print result
                except urllib2.HTTPError as err:
                        break

                time.sleep(1)


                time.sleep(1)

        return


request = urllib2.Request("http://dobrochan.com/api/chan/stats/diff.json", None, headers)
response = urllib2.urlopen(request);
bb = response.read()

try:
        boards = json.loads(bb)
        for board in boards:
                getThreads(board)
except ValueError:
        print "Problem with json"